"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MocksGenerator = exports.indentation = void 0;
const makeArray = (cnt) => Array.from(new Array(cnt));
const indentationLine = (cnt) => (line) => (line === null || line === void 0 ? void 0 : line.length)
    ? makeArray(cnt)
        .map(() => " ")
        .join("") + line
    : "";
const indentation = (cnt = 2) => {
    return (code) => {
        const lines = (code === null || code === void 0 ? void 0 : code.split("\n")) || [];
        return lines.map(indentationLine(cnt)).join("\n");
    };
};
exports.indentation = indentation;
function useString(str) {
    return `'${str}'`;
}
class MocksGenerator {
    constructor() {
        this.options = {
            defaults: {
                arrayLength: 3,
                string: "string",
                boolean: "true",
            },
        };
    }
    generateJsonSchemaMocks(schema, options = null) {
        var _a, _b, _c;
        if (schema.templateIndex !== -1) {
            if ((_a = options === null || options === void 0 ? void 0 : options.tempalteArgs) === null || _a === void 0 ? void 0 : _a.length) {
                return this.generateJsonSchemaMocks(options.tempalteArgs[schema.templateIndex], options);
            }
        }
        if (schema.typeName === "Array") {
            if ((_b = schema.templateArgs) === null || _b === void 0 ? void 0 : _b.length) {
                const item = this.generateJsonSchemaMocks(schema.templateArgs[0]);
                return `[ ${makeArray(this.options.defaults.arrayLength)
                    .map(() => item)
                    .join(",")}]`;
            }
            return "[]";
        }
        if ((_c = schema.enum) === null || _c === void 0 ? void 0 : _c.length) {
            if (schema.type === "string") {
                return useString(schema.enum[0]);
            }
            return schema.enum[0];
        }
        switch (schema.type) {
            case "string": {
                return useString(this.options.defaults.string);
            }
            case "number": {
                return Math.random() * 100 + "";
            }
            case "boolean": {
                return this.options.defaults.boolean;
            }
            case "array": {
            }
            case "object": {
            }
        }
    }
}
exports.MocksGenerator = MocksGenerator;
//# sourceMappingURL=CodeGenerator.js.map