"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterfaceMocks = exports.PontJsonSchemaMocks = void 0;
const _ = __importStar(require("lodash"));
class PontJsonSchemaMocksOptions {
    constructor() {
        this.templateArgs = [];
        this.depth = 3;
        this.definitions = {};
    }
}
class PontJsonSchemaMocks {
    static toMocks(schema, options = new PontJsonSchemaMocksOptions()) {
        var _a, _b;
        if (typeof schema.templateIndex === "number" && schema.templateIndex !== -1) {
            if (options.templateArgs[schema.templateIndex]) {
                return PontJsonSchemaMocks.toMocks(options.templateArgs[schema.templateIndex], Object.assign(Object.assign({}, options), { depth: options.depth - 1, templateArgs: [] }));
            }
        }
        if (schema.typeName) {
            if (options.definitions[schema.typeName]) {
                return PontJsonSchemaMocks.toMocks(options.definitions[schema.typeName], Object.assign(Object.assign({}, options), { depth: options.depth - 1, templateArgs: schema.templateArgs }));
            }
        }
        if (schema.example) {
            return schema.example;
        }
        else if ((_a = schema.examples) === null || _a === void 0 ? void 0 : _a.length) {
            return schema.examples[0];
        }
        else if ((_b = schema.enum) === null || _b === void 0 ? void 0 : _b.length) {
            return schema.enum[0];
        }
        switch (schema.type) {
            case "boolean": {
                return Math.random() > 0.5 ? true : false;
            }
            case "string": {
                return "string";
            }
            case "number": {
                if (schema.format === "int32" || schema.format === "int64") {
                    return Number.parseInt(Math.random() * 100 + "");
                }
                return (Math.random() * 100).toFixed(3);
            }
            case "array": {
                return [
                    PontJsonSchemaMocks.toMocks(schema.items, Object.assign(Object.assign({}, options), { depth: options.depth - 1 })),
                ];
            }
            case "object": {
                if (schema.properties) {
                    return _.mapValues(schema.properties, (property) => {
                        return PontJsonSchemaMocks.toMocks(property, Object.assign(Object.assign({}, options), { depth: options.depth - 1 }));
                    });
                }
                else if (schema.additionalProperties) {
                    return {
                        ["testField1"]: PontJsonSchemaMocks.toMocks(schema.additionalProperties, Object.assign(Object.assign({}, options), { depth: options.depth - 1 })),
                        ["testField2"]: PontJsonSchemaMocks.toMocks(schema.additionalProperties, Object.assign(Object.assign({}, options), { depth: options.depth - 1 })),
                    };
                }
            }
        }
        return null;
    }
}
exports.PontJsonSchemaMocks = PontJsonSchemaMocks;
class InterfaceMocks {
    static toMocks(api, options = new PontJsonSchemaMocksOptions()) {
        var _a, _b;
        const mocksData = PontJsonSchemaMocks.toMocks((_b = (_a = api.responses) === null || _a === void 0 ? void 0 : _a[200]) === null || _b === void 0 ? void 0 : _b.schema);
    }
}
exports.InterfaceMocks = InterfaceMocks;
//# sourceMappingURL=index.js.map